FreezeTime = Mod:init()

--- Register action events on loadMap.
function FreezeTime:loadMap()
	FreezeTime.currentTimeScale = g_currentMission.missionInfo.timeScale

	Player.registerActionEvents = Utils.appendedFunction(Player.registerActionEvents, FreezeTime.registerActionEvents)
	Enterable.onRegisterActionEvents = Utils.appendedFunction(Enterable.onRegisterActionEvents, FreezeTime.registerActionEvents);
end


--- Register the input binding.
function FreezeTime:registerActionEvents()
	if self.isClient then
		local valid, eventId = g_inputBinding:registerActionEvent(InputAction.FREEZE_TIME, InputBinding.NO_EVENT_TARGET, FreezeTime.setTimescale, false, true, false, true);

		if valid then
			g_inputBinding:setActionEventText(eventId, g_i18n:getText("input_FREEZE_TIME"))
			g_inputBinding:setActionEventTextVisibility(eventId, false)
			g_inputBinding:setActionEventTextPriority(eventId, GS_PRIO_VERYLOW)
		end
	end
end


--- Set timeScale to 0 if not 0, or revert to previous timeScale.
-- @param string actionName
function FreezeTime:setTimescale(actionName)
	if actionName == "FREEZE_TIME" then
		if not g_currentMission.isMasterUser then
			return
		end

		if g_currentMission.missionInfo.timeScale ~= 0 then
			FreezeTime.currentTimeScale = g_currentMission.missionInfo.timeScale
			g_currentMission:setTimeScale(0)
		else
			g_currentMission:setTimeScale(FreezeTime.currentTimeScale)
		end
	end
end
